#!/usr/bin/perl
use lib '/home/erealms/ethereal/mgmt/perl';

################################################################################
# Created       : Martin Foster
# Modified      : 03-Oct-2005
################################################################################
#
# Located Tags - Finds no longer used tags
# Copyright (C) 2000-2006  Martin Foster
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
#
# Author of this script can be contacted at the following:
#       E-Mail  : martin@ethereal-realms.org
#       Address : 29-26503 TWP RD 511
#                 Spruce Grove, Alberta
#                 T7Y 1G4
#
#################################################################################

use strict;							# Strict variable enforcement

use Ethereal::Database;						# Database handler

################################################################################
# Data Members
################################################################################

my $database;							# Database handle
my $res;							# Results list
my $statement;							# Defined query

my $count;							# Counter
my $line;							# Line
my $type;							# Type to search in

my $grep = '/bin/grep';
my $find = '/usr/bin/find';
my $wc   = '/usr/bin/wc';

my @types;


################################################################################
# Program Area
################################################################################

	# Connect to Database
	$database = new Ethereal::Database();
	$database->Connect();


	# Determine method
	# To the point or wide scan
	if (defined($ARGV[0]))
	{
		# Push onto array and bypass testing
		push (@types, $ARGV[0]);
	}

	# Wide scans
	else
	{
		# Pull list of types
		$database->GetList(\@types, "SELECT TagType
			FROM Tag
			WHERE TagType <> 'system'
			  AND TagType <> 'vcodes'
			GROUP BY TagType
			ORDER BY TagType");
	}
	

	# Searching
	foreach $type (@types)
	{
		# Pull all tags
		$database->Pull(\$statement, "SELECT
			 TagName AS \"Name\"
			FROM Tag
			WHERE TagName NOT ILIKE 'TagLevel%'
			  AND TagName NOT IN ('TmplMain','TmplTitle','TmplSub','TmplAuth')
			  AND TagType='$type'
			GROUP BY TagName
			ORDER BY TagName");
	
		# Generate initial line
		$line = "DELETE FROM ethereal.Tag WHERE TagType='$type' AND TagName IN (";
	
		# Type
		$type = ucfirst($type);
		
		# Loop and discover
		while ($res = $statement->fetchrow_hashref())
		{
			# Open filehandle
			open(SEARCH, "$grep $res->{Name} `$find ../../main ../../mgmt -type f -exec $grep -l GetHash$type /dev/null {} \\;` | $wc -l|")
			 or die "Cannot open filehandle: $!";
	
			# Display counter
			$count = <SEARCH>;

			# Cleanup
			chomp($count);

			print $count . " - " . $type . " - " . $res->{'Name'} . "\n" ;
		
			# Tag that is no longer used
			$line .= "'" . $res->{'Name'} . "'," unless ($count =~ /[1-9]/); 
		
			# Close
			close(SEARCH);
		}

		# Remove any trailing oddities
		chop($line);

		# Display
		print "\n\n" . $line . ");\n\n";
	}
